/**
* @class
* @constructor
*/
export class Project {
    constructor() {
        this.stages = [];
        this.activeStage = null;
        this.gl = null;
    }

	/**
	* setActiveStage
	* @param {Stage} stage.
	*/
	setActiveStage(stage) {
        this.activeStage = stage;

        this.activeStage.setWebGLContext(this.gl);
	};
	
	/**
	* getActiveStage
	* @returns {Stage}.
	*/
	getActiveStage() {
		return this.activeStage;
	};
	
	/**
	* addStage
	* @param {Stage} stage.
	*/
	addStage(stage) {
        this.stages.push(stage);
	};
	
	/**
	* setWebGLContext
	* @param {WebGLRenderingContext} glCtx.
	* @private
	*/
	setWebGLContext(glCtx) {
        this.gl = glCtx;
	};
}
global.Project = Project;
module.exports.Project = Project;