import Draggabilly from "draggabilly";

/**
 * @class
 * @constructor
 */
export class DraggabillyS {
    /**
     * @param {Object} jsonIn
     * @param {String} jsonIn.id
     * @param {String} jsonIn.paneltitle
     * @param {String} jsonIn.html
     * @param {Function} jsonIn.onShow
     */
    constructor(jsonIn) {
        this.strAttrID = jsonIn.id;
        this.onShow = (jsonIn.onShow !== undefined && jsonIn.onShow !== null) ? jsonIn.onShow : null;
        let htmlStr = (jsonIn.html !== undefined && jsonIn.html !== null) ? jsonIn.html : "";
        this.windowEnabled = true;

        this.target = document.createElement("div");
        document.getElementsByTagName("body")[0].appendChild(this.target);
        this.target.classList.add("SECmenu");
        this.target.innerHTML = `
        <div style="font-size:12px; box-shadow:rgba(0, 0, 0, 0.683594) 3px 3px 8px 1px,rgb(255, 255, 255) 0 0 5px 0 inset; border-radius:5px;resize:both;overflow:auto;background:rgba(50,50,50,0.95);">
            <div id="elDS_Panel" style="border-top-left-radius:5px; border-top-right-radius:5px; width:100%; background:rgba(200,200,200,0.7); cursor:move;	display:table;">
                <div style="padding-left:5px;color:#000;font-weight:bold;display:table-cell;vertical-align:middle;">${jsonIn.paneltitle}</div>
                <div style="width:30px;	padding:2px; display:table-cell; vertical-align:middle;">
                    <div id="elDS_TitleMin" style="cursor:pointer;display:inline-block">&#8863;</div>
                    <div id="elDS_TitleClose" style="cursor:pointer;display:inline-block">&#8864;</div>
                </div>
            </div>
            <div id="${this.strAttrID}_content" style="border-bottom-left-radius:5px; border-bottom-right-radius:5px; min-width:220px;	cursor:default;	padding:5px; color:#FFF;  overflow-y:auto;">
                
            </div>
        </div>
        `;

        let dragg = new Draggabilly(this.target, {
            handle: '#elDS_Panel'
        });
        this.target.style.left = (-this.target.getBoundingClientRect().left+100)+"px";
        this.target.style.top = (-this.target.getBoundingClientRect().top+100)+"px";

        if(htmlStr === null) {
            let e = this.target;
            e.parentNode.removeChild(e);
            document.getElementById(`${this.strAttrID}_content`).appendChild(e);
        } else document.getElementById(`${this.strAttrID}_content`).innerHTML = htmlStr;

        //this.appendStringChild(this.target, document.getElementsByTagName("body")[0], "init");

        this.target.querySelector("#elDS_TitleClose").addEventListener('click', (e) => {
            this.hide();
        });

        this.target.querySelector("#elDS_TitleMin").addEventListener("click", () => {
            if(this.windowEnabled === true) {
                this.windowSavedPosLeft = this.target.style.left;
                this.windowSavedPosTop = this.target.style.top;
                this.target.style.position = "absolute";
                this.target.style.left = "50";
                this.target.style.top = "0";
                this.target.style.width = "150px";
                this.target.querySelector(`#${this.strAttrID}_content`).style.display = "none";
                this.target.querySelector("#elDS_TitleMin").innerHTML = "&#8862;";
                this.windowEnabled = false;
            } else {
                this.target.style.position = "relative";
                this.target.style.left = this.windowSavedPosLeft;
                this.target.style.top = this.windowSavedPosTop;
                this.target.style.width = "950px";
                this.target.querySelector(`#${this.strAttrID}_content`).style.display = "block";
                this.target.querySelector("#elDS_TitleMin").innerHTML = "&#8863;";
                this.windowEnabled = true;
            }
        });

        dragg.on('pointerUp', (e, pointer) => {
            this.target.click();
            this.upZindex();
            e.stopPropagation();
            e.preventDefault();
        });

        this.hide();
    }

    appendStringChild(str, target, location) {
        let loc = (location !== undefined) ? location : "end";
        let parser = new DOMParser();
        let e = parser.parseFromString(str, "text/html");

        if(loc === "end")
            this.target.appendChild(e.body.firstChild);
        else
            this.target.insertBefore(e.body.firstChild, this.target.firstChild);
        //return e.body.firstChild;
    };

    /**
     * show
     */
    show() {
        this.target.style.display = "block";
        this.upZindex();
    };

    /**
     * hide
     */
    hide() {
        this.target.style.display = "none";
    };

    upZindex() {
        let list = document.querySelectorAll(".SECmenu");
        for(let value of list.values())
            value.style.zIndex = '0';

        this.target.style.zIndex = '99';
    };
}
global.DraggabillyS = DraggabillyS;
module.exports.DraggabillyS = DraggabillyS;