import {Constants} from "../Constants";
import {UIComponentGPU} from "./UIComponentGPU.class";
import {DraggabillyS} from "./DraggabillyS.class";

/**
* @class
* @constructor
*/
export class PanelNode {
    constructor() {
        this.panel = new DraggabillyS({ "id": 'PanelEditNode',
                                        "paneltitle": 'NODE',
                                        "html": `<span style="font-weight:bold" id="DIVID_StormEditNode_name"></span>
                                                <div id="DIVID_StormEditNode_edits"></div>`});
        this.panel.target.style.width = "800px";


        this.elContentName = this.panel.target.querySelector('#DIVID_StormEditNode_name');
        this.elContent = this.panel.target.querySelector('#DIVID_StormEditNode_edits');
    }

	/**
	 * show
	* @param {Node} selectedNode
	*/
	show(selectedNode) {
        this.panel.show();

        this.updateNearNode(selectedNode);
	};

	/**
	* updateNearNode
	* @param {Node} selectedNode
	* @private
	*/
	updateNearNode(selectedNode) {
		if(selectedNode === undefined || selectedNode === null) {
            this.elContentName.innerHTML = "";
            this.elContent.innerHTML = "";
		} else {
			if(selectedNode.getName() !== "")
                this.elContentName.innerHTML = selectedNode.getName();

            this.elContent.innerHTML = "";
			
			for(let compTypeKey in Constants.COMPONENT_TYPES) {
				for(let nodeCompKey in selectedNode.getComponents()) {
					if(nodeCompKey === Constants.COMPONENT_TYPES[compTypeKey].toString()) {
						let str = 	"<div id='DIVID_component_"+compTypeKey+"' class='component StormShadow02 StormRound'>"+
										compTypeKey+
									"</div>";

                        this.elContent.innerHTML += str;
						
						if(nodeCompKey === Constants.COMPONENT_TYPES.GPU.toString()) {
							new UIComponentGPU(compTypeKey, selectedNode);
						} else if(nodeCompKey === Constants.COMPONENT_TYPES.PROJECTION.toString()) {
							
						}
					}
				}	
			}
				
		
		}
	};
}
global.PanelNode = PanelNode;
module.exports.PanelNode = PanelNode;