import {ActionHelpers} from "./ActionHelpers.class";
import Draggabilly from "draggabilly";
import {DraggabillyS} from "./DraggabillyS.class";
/**
* @class
* @constructor
*/
export class PanelNumberGenerator {
    constructor() {
        this.ah = new ActionHelpers();

        this.panel = new DraggabillyS({ "id": 'DIVID_PanelNumberGenerator',
                                        "paneltitle": 'NUMBER GENERATOR'});
        this.panel.target.style.width = "500px";
    }

	show() {
        this.panel.show();

        this.showListObjects();
	};

	showListObjects() {
		let eContent = document.getElementById('DIVID_PanelNumberGenerator_content');
		eContent.innerHTML = "";

        this.ah.add_imageSelection(eContent, "LOAD_IMG", function(img) {
			eContent.appendChild(img);
			eContent.innerHTML += img.width+"x"+img.height+"="+img.width*img.height;
			
			img.setAttribute("draggable", true);
			img.addEventListener('dragstart', function(evt) {
				evt.dataTransfer.effectAllowed = 'move';
				evt.dataTransfer.setData("text/plain", img.src);
			}, false);
		});


        let getArr = (function(arr, elementItems) {
            let arrayOut = [];
            let itemValues = [];

            let length = arr[0];
			for(let n=1; n < arr[1]; n++)
				length *= arr[0];

            let repeat = arr[2];
			
			for(let n=0; n < length*arr[2]; n++) {
				if(repeat === arr[2]) {
					repeat = 0;
					itemValues = [];
					
					for(let i=0; i < elementItems; i++)
						itemValues.push(1.0-(Math.random()*2.0));
				}
				for(let i=0; i < elementItems; i++)
					arrayOut.push(itemValues[i]);
				
				repeat++;				
			}


            let btn = document.createElement("button");
			btn.innerHTML = "arr";
			btn.setAttribute("draggable", true);
			eContent.appendChild(btn);
			
			btn.addEventListener('dragstart', (function(arrayOut, evt) {
				console.log(arrayOut);
				evt.dataTransfer.effectAllowed = 'move';
				evt.dataTransfer.setData("text/plain", arrayOut);
			}).bind(this, arrayOut), false);
		}).bind(this);

        this.ah.add_valuesAndBtn(eContent, "CREATE_RANDOM_FLOAT", "number", ["length", "dimensions", "repeat_FLOAT"], [128, 2, 14],
				(function(arr) {
					getArr(arr, 1);
				}).bind(this));

        this.ah.add_valuesAndBtn(eContent, "CREATE_RANDOM_FLOAT4", "number", ["length", "dimensions", "repeat_FLOAT4"], [128, 2, 14],
				(function(arr) {
					getArr(arr, 4);
				}).bind(this));
		
	};
}
global.PanelNumberGenerator = PanelNumberGenerator;
module.exports.PanelNumberGenerator = PanelNumberGenerator;