import {DraggabillyS} from "./DraggabillyS.class";

/**
* @class
* @constructor
*/
export class PanelStage {
    constructor() {
        this.panel = new DraggabillyS({ "id": 'DIVID_PanelStage',
                                        "paneltitle": 'STAGE'});
        this.panel.target.style.width = "250px";

        this.elContent = this.panel.target.querySelector('#DIVID_PanelStage_content');
    }

	/**
	 * @callback PanelStage~onselect
	 * @param {Node} node
	 */
	/**
	* show
	* @param {Array<Node>} nodes
	* @param {Node} selectedNode
	* @param {PanelStage~onselect} onselect
	*/
	show(nodes, selectedNode, onselect) {
        this.panel.show();
		
		this.showListObjects(nodes, selectedNode, onselect);
	};
	
	/**
	* showListObjects
	* @param {Array<Node>} nodes
	* @param {Node} selectedNode
	* @param {PanelStage~onselect} onselect
	* @private
	*/
	showListObjects(nodes, selectedNode, onselect) {
	    let drawItems = (nodes, selectedNode, onselect) => {
            this.elContent.innerHTML = "";
            let str = '';
            for(let n=0, f = nodes.length; n < f; n++) {
                let colorBg = (selectedNode !== undefined && selectedNode === nodes[n]) ? '#444' : '#000';
                let colorText = (nodes[n].isEnabled() === true) ? '#FFF': '#999';
                str = "<div id='TDID_StormObjectNum_nodes"+n+"' style='background-color:"+colorBg+";color:"+colorText+";'>"+nodes[n].getName()+"</div>";
                this.elContent.innerHTML += str;
            }

            for(let n=0, f = nodes.length; n < f; n++) {
                let e = document.getElementById("TDID_StormObjectNum_nodes"+n);
                e.addEventListener("click", (event) => {
                    e.style.backgroundColor = "#444";
                    onselect(nodes[n]);

                    drawItems(nodes, nodes[n], onselect);
                });
            }
        };

        drawItems(nodes, selectedNode, onselect);


        this.elContentDiv = this.panel.target.querySelector('#DIVID_PanelStage_content div');
        this.elContentDiv.style.cursor = 'pointer';
        this.elContentDiv.style.border = '1px solid #444';

        this.elContentDiv.addEventListener('mouseover', () => {
            this.elContentDiv.style.border = '1px solid #CCC';
        });

        this.elContentDiv.addEventListener('mouseout', () => {
            this.elContentDiv.style.border = '1px solid #444';
        });
	};
}
global.PanelStage = PanelStage;
module.exports.PanelStage = PanelStage;