import {PanelStage} from "./PanelStage.class";
import {PanelNode} from "./PanelNode.class";
import {PanelNumberGenerator} from "./PanelNumberGenerator.class";
import {ActionHelpers} from "./ActionHelpers.class";
/**
* @class
* @constructor
*/
export class UI {
    constructor(project) {
        this._project = project;
        this.panel_Stage = null;
        this.panel_Node = null;
        this.panel_NumberGenerator = null;
    }

	/**
	 * render
	 * @param {HTMLDivElement} target
     * @param {HTMLCanvasElement} canvas
	 */
	render(target, canvas) {
		let str = `<div style="font-size:10px;">
            <div id="TOPMENU_`+target.id+`_view_PanelStage" style="display:inline-block;cursor:pointer;">Stage - </div>
            <div id="TOPMENU_`+target.id+`_view_PanelNode" style="display:inline-block;cursor:pointer;">Node - </div>
            <div id="TOPMENU_`+target.id+`_view_PanelNumberGenerator" style="display:inline-block;cursor:pointer;">Number Generator</div>
		</div>`;
		ActionHelpers.appendStringChild(str, target, "init");

        this.panel_Stage = new PanelStage();
        this.panel_Node = new PanelNode();
        this.panel_NumberGenerator = new PanelNumberGenerator();

        target.querySelector("#TOPMENU_"+target.id+"_view_PanelStage").addEventListener("click", (e) => {
			e.preventDefault();
			e.stopPropagation();
            this.panel_Stage.show(this._project.getActiveStage().getNodes(), this._project.getActiveStage().getSelectedNode(), (node) => {
                this._project.getActiveStage().setSelectedNode(node);

                this.panel_Node.show(this._project.getActiveStage().getSelectedNode());
			});
		});

        target.querySelector("#TOPMENU_"+target.id+"_view_PanelNode").addEventListener("click", (e) => {
			e.preventDefault();
			e.stopPropagation();
            this.panel_Node.show(this._project.getActiveStage().getSelectedNode());
		});

        target.querySelector("#TOPMENU_"+target.id+"_view_PanelNumberGenerator").addEventListener("click", (e) => {
			e.preventDefault();
			e.stopPropagation();
            this.panel_NumberGenerator.show();
		});
	}; 
}
global.UI = UI;
module.exports.UI = UI;