import {UIComponentGPU_Indices} from "./UIComponentGPU_Indices.class";
import {UIComponentGPU_Argument} from "./UIComponentGPU_Argument.class";
import {UIComponentGPU_Kernel} from "./UIComponentGPU_Kernel.class";
import {UIComponentGPU_Vfp} from "./UIComponentGPU_Vfp.class";
import {Constants} from "../Constants";
import {ActionHelpers} from "./ActionHelpers.class";

/**
* @class
* @constructor
*/
export class UIComponentGPU {
    constructor(compTypeKey, selectedNode) {
        this.comp = selectedNode.getComponent(Constants.COMPONENT_TYPES.GPU);

        let args = this.comp.getAllArgs();


        let str = ""+
            "<div id='DIVID_"+compTypeKey+"' class='component_section'>"+
                "<div id='DIVID_"+compTypeKey+"_args' style='width:300px;display:inline-block;'></div>"+
                "<div id='DIVID_"+compTypeKey+"_kernelsvfps' style='display:inline-block;vertical-align:top;'></div>"+
            "</div>";
        ActionHelpers.appendStringChild(str, document.getElementById('DIVID_component_'+compTypeKey));



        // INDICES
        new UIComponentGPU_Indices(document.getElementById('DIVID_'+compTypeKey), selectedNode, this.comp, args);

        // ARGS
        new UIComponentGPU_Argument(document.getElementById('DIVID_'+compTypeKey+'_args'), selectedNode, this.comp, args);

        //KERNELS
        new UIComponentGPU_Kernel(document.getElementById('DIVID_'+compTypeKey+'_kernelsvfps'), selectedNode, this.comp, args);

        // VFPS
        new UIComponentGPU_Vfp(document.getElementById('DIVID_'+compTypeKey+'_kernelsvfps'), selectedNode, this.comp, args);
    }
}
global.UIComponentGPU = UIComponentGPU;
module.exports.UIComponentGPU = UIComponentGPU;